/*
 *
 * Simple program that sniffs various packets from the net.
 * Only for study ;-)
 * 
 * by: LexLufix
 * Lex@Lufix.net 
 * http://www.lufix.net/
 *
 * */

#define VERSION 0.1.1

#include "config.h"

#include <sys/types.h>

#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef HAVE_TIME_H
#include <time.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#include <pcap.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif

/* protocol specific headers */
#include "ip.h"
#include "ip6.h"
#include "icmp6.h"
#include "udp.h"
#include "tcp.h"
#include "ip_icmp.h"
#include "ether.h"
#include "dns.h"

#define SNAPLEN 2048
#define ETH_ALEN 6

/* port definitions */
#define PORT_DNS			53

struct sockaddr localaddr;
socklen_t	locallen;

int datalink, snaplen, compile,
		verbose, names, etherp, counto, count;

char *device, *data, *compstr;
int enet_hdr;
pcap_t *pd;

char *copy_argv(char **);
void open_pcap();
void readloop();
void print_hadrs(uint8_t *, uint8_t *);
void print_etheradr(uint8_t *);
void print_ip6addr(const char *);
void print_time(struct timeval *);
void checkcount();
void checkport(uint16_t, uint16_t, char *);
void cleanup();
void usage(const char *);
void banner();

void *ip_process(char *, int);
void *ip6_process(char *, int);

void *ip6hopopts_process(char *);
void *ip6dstopts_process(char *);
void *ip6rout_process(char *);
void *ip6frag_process(char *);

/* protocol specific functions */
void *tcp_process(char *);
void udp_process(char *);
void icmp_process(char *);
void icmp6_process(char *);
void arp_process(char *, uint8_t sender[ETH_ALEN], uint8_t target[ETH_ALEN]);
void scanEtherProt(uint16_t);

void dns_process(char *);

